require 'gaussian_elimination'
class LeastSquaresMethod
  def initialize
    @data = []
  end
  
  def input_data(filename, mark = ",")
    @data = []
    open(filename,"r") do |file|
      file.each_line do |line|
        @data.push(line.split(mark).map{|v| v.to_f})
      end
    end
  end
  
  def polynomial(m = 1)
    return "Dimension Error" if m < 1
    return "No Data" if @data.empty?
    invs_x,invs_f = involutions(m)
    equations = Array.new(m + 1){[]}
    equations.each_with_index do |eqation, n|
      (m+2).times do |k|
        if k == m + 1
          p = m - n
          eqation.push(invs_f[p])
        else
          p = 2*m - n - k
          eqation.push(invs_x[p])
        end
      end
    end
    return GaussianElimination.new.solve(*equations)
  end
  
  def involutions(m)
    data_x, data_f = @data.transpose
    invs_x = [data_x.size]
    invs_f = [data_f.inject(:+)]
    1.upto(2*m) do |n|
      invs_x.push(data_x.inject(0){|sum,x| sum + x**n})
      invs_f.push(@data.inject(0){|sum,d| sum + d[1]*(d[0]**n)}) if n <= m
    end
    return invs_x,invs_f
  end
end

lsm = LeastSquaresMethod.new
lsm.input_data("data.txt",",")
p lsm.polynomial(1)
